#!/usr/bin/perl

######################################################################
#  Cognition/0.1-alpha4 - A metadata browser
#  Copyright (c) 2008 Toby Inkster.
######################################################################
#
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
######################################################################

use strict;
use lib '.';
use CGI qw(:standard);
use CGI::Carp 'fatalsToBrowser';
use Cognition::HTMLParser;
use Data::Dumper;
use LWP::RobotUA;
use LWP::UserAgent;
use HTTP::Request;
use Syntax::Highlight::HTML;

my $q = new CGI;

my $url = $q->param('url');
my ($check1, $check2) = ('', 'checked="checked"');
if ($q->param('format') eq 'perl')
{
	($check1, $check2) = ('checked="checked"', '');
}

print &header;

print "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01//EN\" \"http://www.w3.org/TR/html4/strict.dtd\">\n";
print "<title>cognition/0.1-alpha4</title>\n";
print "<link href=\"cognition.css\" rel=\"stylesheet\" type=\"text/css\">\n";
print "<h1>cognition/0.1-alpha4</h1>\n";
print "<form class=\"cool\" id=\"cogform\" method=\"get\" action=\"#\">\n";
print "  <label for=\"url\">URL:</label>\n";
print "  <input id=\"url\" name=\"url\" value=\"".escapeHTML($url)."\">\n";
print "  <input id=\"submit\" type=\"submit\"><br>\n";
print "  <input id=\"formatperl\" name=\"format\" value=\"perl\" type=\"radio\" $check1>\n";
print "  <label for=\"formatperl\">Perl Data::Dumper</label>\n";
print "  &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;\n";
print "  <input id=\"formatrdf\" name=\"format\" value=\"rdf\" type=\"radio\" $check2>\n";
print "  <label for=\"formatrdf\">RDF Dump</label>\n";
print "</form>\n";

if (length $url)
{
	print "<pre>\n";

	my $ua = LWP::RobotUA->new(
		agent      => 'cognition/0.1-alpha4 ',
		from       => 'invalid@invalid.invalid'
	);
	$ua->delay(5/60);

	my $request  = HTTP::Request->new(GET => $url);
	my $response = $ua->request($request);
	my $x        = Cognition::HTMLParser->new(
			$response->content, 
			{
				ua        => $ua,
				response  => $response,
				request   => $request
			}
		);

	if ($q->param('format') eq 'perl')
	{
		print escapeHTML($x->dumpTextClean);
	}
	else
	{
		my $highlighter = new Syntax::Highlight::HTML;
		print $highlighter->parse($x->dumpRDF);
	}
	print "</pre>\n";
}
else
{
	print "<p class=\"warn\">No URL entered!</p>\n";
}
